#include <string>
#include <iostream>

#include "FileNavigator.h"
#include "ISTable.h"

using namespace std;

static void ShowUsage(void);


int main(int argc, char** argv)
{

    int err = 0;
    int size;

    if (argc < 2)
    {
        ShowUsage();
        exit(1);
    }

    string inFile = argv[1];

    FileNavigator* fnav = new FileNavigator();

    ISTable table;

    fnav->OpenFile(inFile, READ_MODE, 0);

    fnav->ReadFileHeader();

    table.GetObject(err, fnav, size);

    cout << table;

    fnav->CloseFile();

    delete fnav;

    exit(0);

} /* End of main() */


void ShowUsage(void)
{

    cout << "Usage: ISTableReader input_odb_file" << endl;

}
