/* 
    File: ISTest5.C
*/

#include <string>
#include <iostream>

#include "ISTable.h"

using namespace std;


// prototypes

void FillTestTable(ISTable *s);
void PrintArray(const vector<unsigned int>& target);

int main(int argc, char** argv) {

  ISTable *ss;
  string fname;
  vector<string> list;
  vector<string> list2;
  vector<string> list3;
  vector<string> list4;
  int recNo;
  int size;
  vector<unsigned int> listOut;
  vector<string> list5;
  vector<string> list6;
  Word ind;

  ss = new ISTable(string("pera"));
  FillTestTable(ss);

  ss->SetFlags("start_v", ISTable::DT_INTEGER);
  ss->SetFlags("end_v", ISTable::DT_INTEGER);
  ss->SetFlags("lp_lenght", ISTable::DT_INTEGER);

  vector<string> colNames;
  ss->GetColumnNames(colNames);

  list.push_back(colNames[0]);
  list.push_back(colNames[1]);

  list3.push_back(colNames[1]);
  list3.push_back(colNames[2]);

  ss->CreateIndex("index0",list);
  ss->CreateIndex("index1",list3);

  vector<string>* newRow;
  newRow = new vector<string>;
  newRow->push_back("49");
  newRow->push_back("0");
  newRow->push_back("new");

  ss->AddRow();
  ss->FillRow(ss->GetLastRowIndex(), *newRow);

  ss->AddRow();
  ss->FillRow(ss->GetLastRowIndex(), *newRow);
  list2.push_back("48");
  list2.push_back("1");
  list4.push_back("0");
  // VLAD: BUG Why are we putting this "new" string in the list of numbers.
  // This creates problems when we want to convert the value to an integer. We
  // end up invoking ConvertToInt with a string "new" that does not represent
  // an integer.
  list4.push_back("new");

  ss->AddRow();
  cout<<"GetNumRows = "<<ss->GetNumRows()<<endl;
  ss->FillRow(ss->GetLastRowIndex(), *newRow);

  list5.push_back(colNames[1]);
  list5.push_back(colNames[2]);
  list6.push_back("0");
  list6.push_back("0");


  recNo=ss->FindFirst(list6, list5);
  cout<<"recNo = "<<recNo<<endl;

  ss->DeleteRow(50);

  ss->Search(listOut, list2, list);
  PrintArray(listOut);

  listOut.clear();
  ss->Search(listOut, list6, list5, ISTable::eLESS_THAN, "index1");
  PrintArray(listOut);

  fname = "outfile.db";

  FileNavigator *fnav;
  int err;
  fnav = new FileNavigator();
  err=fnav->OpenFile(fname, CREATE_MODE, 1);
  if (err) fnav->PrintError(err);
  err=fnav->ReadFileHeader();
  if (err) fnav->PrintError(err);
  err = ss->WriteObject(fnav, size);
  fnav->CloseFile();
  delete fnav;

  fnav = new FileNavigator();
  ISTable gnu,gnu2;
  fnav->OpenFile("outfile.db", READ_MODE,0);
  fnav->ReadFileHeader();
  ind=0;
  gnu.GetObject(ind, fnav, size);
  recNo=gnu.FindFirst(list2, list, "index0");
  cout<<"recNo = "<<recNo<<endl;
  recNo=gnu.FindFirst(list4, list3, "index1");
  cout<<"recNo = "<<recNo<<endl;
//  gnu.PrintTable("index0");

  delete newRow;
  delete ss;
  fnav->CloseFile();
  delete fnav;
  exit(0);
}


void FillTestTable(ISTable *s) {
 int i;
 vector<string>* ColStart;
 vector<string>* ColEnd;
 vector<string>* ColLen;
 ColStart = new vector<string>;
 ColEnd = new vector<string>;
 ColLen = new vector<string>;
 string length;
 char a[5];
 s->AddColumn("start_v");
 s->AddColumn("end_v");
 s->AddColumn("lp_lenght");
 for (i=0; i<50; i++) {
   sprintf(a,"%d",49-i);
   length = a;
	ColStart->push_back(length);
   sprintf(a,"%d",i);
   length = a;
	ColEnd->push_back(length);
	ColLen->push_back(length);
 }

 s->FillColumn("start_v", *ColStart);
 s->FillColumn("end_v", *ColEnd);
 s->FillColumn("lp_lenght", *ColLen);

 delete ColStart;
 delete ColEnd;
 delete ColLen;
}



void PrintArray(const vector<unsigned int>& target) {
  if (!target.empty()) {
    int len = target.size();
    for (int i = 0; i < len - 1; i++) {
      cout << target[i] << ", ";
    }
    if (len > 0)
      cout << target[len - 1];
  }
  cout << endl;
}
